#!/usr/bin/perl -w
#use strict; # please
use Carp qw| cluck :DEFAULT |;
#this file will use the extracted data file to create NNprep files depending on the option selected
$data = $ARGV[0];
$length = $ARGV[1];
$option = $ARGV[2];
$dir = $ARGV[3];
our $dbg = $ARGV[4];
@amino = ('A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V');
%prop = ();
%{$prop{"A"}} = (mass => 71, hyd => 50, charge => 50, cbeta => 0, surface => 0); 
%{$prop{"C"}} = (mass => 103, hyd => 100, charge => 50, cbeta => 0, surface => 100);
%{$prop{"D"}} = (mass => 115, hyd => 0, charge => 0, cbeta => 0, surface => 50);
%{$prop{"E"}} = (mass => 130, hyd => 0, charge => 0, cbeta => 0, surface => 100);
%{$prop{"F"}} = (mass => 147, hyd => 100, charge => 50, cbeta => 0, surface => 100);
%{$prop{"G"}} = (mass => 57, hyd => 50, charge => 50, cbeta => 0, surface => 0);
%{$prop{"H"}} = (mass => 137, hyd => 50, charge => 80, cbeta => 0, surface => 100);
%{$prop{"I"}} = (mass => 113, hyd => 100, charge => 50, cbeta => 100, surface => 100);
%{$prop{"K"}} = (mass => 128, hyd => 25, charge => 100, cbeta => 0, surface => 100);
%{$prop{"L"}} = (mass => 113, hyd => 100, charge => 50, cbeta => 0, surface => 100);
%{$prop{"M"}} = (mass => 131, hyd => 100, charge => 50, cbeta => 0, surface => 100);
%{$prop{"N"}} = (mass => 114, hyd => 0, charge => 50, cbeta => 0, surface => 50);
%{$prop{"P"}} = (mass => 97, hyd => 50, charge => 50, cbeta => 0, surface => 0);
%{$prop{"Q"}} = (mass => 128, hyd => 0, charge => 50, cbeta => 0, surface => 100);
%{$prop{"R"}} = (mass => 157, hyd => 25, charge => 100, cbeta => 0, surface => 100);
%{$prop{"S"}} = (mass => 87, hyd => 50, charge => 50, cbeta => 0, surface => 0);
%{$prop{"T"}} = (mass => 101, hyd => 50, charge => 50, cbeta => 100, surface => 50);
%{$prop{"V"}} = (mass => 99, hyd => 100, charge => 50, cbeta => 100, surface => 100);
%{$prop{"W"}} = (mass => 186, hyd => 100, charge => 50, cbeta => 0, surface => 100);
%{$prop{"Y"}} = (mass => 163, hyd => 50, charge => 50, cbeta => 0, surface => 100);

$prev_node = 0;
$file = $data;
#output file is $file.NNprep
$file =~ s/(.+\/)*//;
$file .= ".L$length.$option";
$file =~ s/Processed//;
if( $dbg ){ warn( "Out file will be $dir/$file" ); }
#EDITED TO ACCOMODATE FOR SIFT AND TRANSITIONS and May 3 (mass diff, hydrophobicity diff, charge diff, burried charge (mut org) for all)
#Input:
# 1 -- file name (eg Test for Test.out, Test.Pfam, Test.Rel
# 2 -- length of surrounding value
# 3 -- things to be extracted where:
#	pos 1 -- sequence (0 - no sequence)
#	pos 2 -- profile (2 -- frequency + gapless)
#	pos 3 -- rel accessability (1 -- acc + reliability)
#	pos 4 -- sec structure (1 -- structure(network out) + reliability)
#	pos 5 -- pfam (2 -- domain + score + seed + match)
#	pos 6 -- psic (2 -- psic score for mut stretch + diff for mut only).
# 	pos 7 -- non-align prof (1 - diff between otH, otE, otL, and pAcc)
#	pos 8 -- 3 - sift and transition
#	pos 9 -- 1 - bval
#	pos 10 -- 0 -- no polyphen
#	pos 11 -- 1 - swissprot
$u = "";
$u_tot = 0;
#get the unknown representation
#foreach my $i (1..20){ $u .= "5\t"; } # the same:	
$u .= "5\t" x 20;
$u .= "0\t0\t50\t0\t0\t0\t0\t0\t100\t0\t0\t50\t";
$u_tot += 32;

open (IN, $data) || die "Can't open $data\n";
$entry_count = 0;
open (OUT, ">$dir/$file");
$flag = 0;
$posi = 0;
$negi = 0;
$within_c = 0;
$node = 0;
$number = 0;
$skip = 0;
$pssm_a = "";
foreach $line (<IN>){
	#if we are skipping these
	if (($within_c == 1) and ($skip > 0) and (!($line =~ /\>/))){
		$skip--;
		next;
	}
	#get rid of trailer tab
	$line =~ s/\s*\n//;
	$line .= "\t\n";
	#if we are at new entry
	if ($line =~ /^>/o){
		$skip = 0;
		$mut_vis = "";
		#if we need to print out U's at the end that were not printed
		if ($flag == 1){
			#find out how many times we need to print
			$dif = $end - $number;
			while ($dif > 0){
				print OUT "$u";
				$dif--;
				$node += $u_tot;
			}
		}
		$prev_node = $node;
		#print out function for entries that were already processed
		if ($within_c > 0){
			$func = $func* 100;
			print OUT "$func\n";
		}
		#reset flag
		$flag = 0;
		$entry_count++;
		print OUT ">$entry_count\t";
		#get function
		$line =~ s/\>\s+(.+)\s+([A-Z])\s+(\d+)\s+([A-Z])\s+(.+)\t\n//;
		$org = $2;
		$pos = $3;
		$sub = $4;
		$func = $5;
		#print $name_gene."\n";
		if (($func =~ /[^0-9\-\.]/) or (!($func == 0))){
			$posi++;
			$func = 1;
		}
		else{
			$negi++;
			$func = 0;
		}
		#null within protein count
		$within_c = 1;
		$node = 0;
		$start = $pos - $length;
		$end = $pos + $length;
	}
	#if we are at first line, containing the number of the amino acid
	elsif ($within_c == 1){
		$mut_vis = &printSeq($line);
		if ($mut_vis =~ /\d/){
			$within_c++;
		}
	}
	#this is the PSSM line for regular residues and the non-aligned prof line for mutant
	elsif ($within_c == 2){
		#for the mutant print the non-align difference
		if ($mut_vis){
			$line =~ s/\n//;
			print OUT $line;
			$node += 4;
		}
		$within_c++;
	}
	#this contains the frequency for the regular residue and pfam data for the mutant 
	elsif ($within_c == 3){
		if ($mut_vis == 0){
			$line =~ s/\n//;
			print OUT $line;
			$node += 20;
			if ($number == $pos){
				$pssm_a = &printPSSM ($line, "amino");
				print OUT $pssm_a;
			}
		}
		else{
			$line =~ s/\n//;
			$line =~ s/^(\d+\t\d+\t)\d+\t\d+\t\d+\t(\d+\t\d+\t).+/$1$2/;
			print OUT $line;
			$node += 4;
		}
		$within_c++;
	}
	#this contains the gapless matches score and PSIC and SIFT and Transition data in mutant
	elsif ($within_c == 4){
		if ($mut_vis == 0){
			$line =~ s/\n//;
			if( $line =~ /[^\s\d]/ ) { confess( "Non-numeric data in line '$line'" ); }
			print OUT "$line";
			$node += 2;
			$within_c++;
		}
		else{
			#print for mutant ($bie contain stuff from original data)
			##including overal data for mutant mass, hydro, charge, cbeta, surface differences and buried charge)
			foreach $extra_k (keys %{$prop{$org}}){
				$diff_ex = sqrt (($prop{$org}{$extra_k} - $prop{$sub}{$extra_k}) *($prop{$org}{$extra_k} - $prop{$sub}{$extra_k}));
				#print "$diff_ex\t";
				print OUT "$diff_ex\t";
				$node++;
			}
			#print "s$hash{$sub}{"charge"}."\n";
			if (($bie == 0) and (!($prop{$sub}{"charge"} == 50))){
				print OUT "100\t";
			}
			else{
				print OUT "0\t";
			}
			if (($hel eq 'H') and ($sub =~ /P/)){
				print OUT "100\t";
			}
			else{
				print OUT "0\t";
			} 
			$node+=2;
			#reset for after mutant data is done
			$within_c = 1;
			if( $dbg ){ warn( "$line"); }
			# good: '0	22	38	22	0	0	0	0	0	100	100	1	100	3	100	2	100	17'
			# good: '100	21	0	21	0	0	0	0	0	0	50	50	100	218	100	27	0	14'
			# bad:  '100	0	R	0	0	0	0	0	0	0	50	50	100	218	100	27	0	14'
			if( $line !~ /((\d+\t){4})((\d+\t){6})((\d+\t){2})((\d+\t){6})\n/o ){ confess("invalid format of line '$line'"); }
			$psic = $1;
			$swiss = $3;
			$sift = $5;
			$transition = $7;		
			print OUT "$psic";
			$node += 4;
			print OUT "$sift";
			$node += 2;
			print OUT "$transition";
			$node += 6;
			print OUT "$swiss";
			$node += 6;
		}
	}
	#this contains accessability and secondary structure info
	#RI_S    PREL    RI_A    Pbie     OtH     OtE     OtL
	elsif ($within_c == 5){
		#prel + reliability
		$t_line = $line;
		#print just the reliability of acessability an relative accessability
		#print the 3-node accesability and reliability
		$t = $line;
		$t =~ s/\n//;
		$t =~ s/^\d+\t\d+\t(\d+)\t(\d+)\t(\d+)\t(\d+)\t(\d+)//;
		$t = $1;
		$bie = $2;
		$h = $3;
		$e = $4;
		$l = $5;
		if (($h >= $e) and ($h >= $l)){
			$hel = 'H';
		}
		else{
			$hel = 'L';
		}
		
		$line =~ s/\n//;
		$line =~ s/^\d+\t(\d+\t\d+\t).+/$1/;
		print OUT $line;
		$node += 2;
		$line = $t_line;
		#print just the secondary structure reliability and 3 node net output format
		$line =~ s/\n//;
		$line =~ s/^(\d+\t).+(\d+\t\d+\t\d+\t)$/$1$2/;
		print OUT $line;
		$node += 4;		
		$within_c++;
	}  
	#now dealing with psic 
	elsif ($within_c == 6){
		$line =~ s/\n//;
		print OUT $line;
		$node += 3;
		$within_c++;
	}
	#now dealing with flexibility
	elsif ($within_c == 7){
		$line =~ s/\n//;
		print OUT $line;
		$node += 1;
		$within_c = 1;
	}
}
#if U's are needed at the end
if ($flag == 1){
	#find out how many times we need to print
	$dif = $end - $number;
	while ($dif > 0){
		print OUT "$u";
		$dif--;
		$node += $u_tot;
	}
}

#print out function the last time
$func = $func* 100;
print OUT "$func\n";
if( $dbg ){ warn("$func"); }

close IN;
close OUT;		

open (SUM, ">$dir/$file.sum");
print SUM "Total nodes = $node\n";
print SUM "$posi positives, and $negi negatives, total ";
$posi = $posi + $negi;
print SUM "$posi entries\n";
close SUM;

exit(0);

# END OF PROGRAM -------------------------------------------------------------

sub printSeq{
	my( $line ) = @_;
	#get the number of amino acid if the line is not mutant
	if (!($line =~ "Mut")){
		$line =~ s/^(\d+)\t//;
		$number = $1;
		#if we are not yet at start
		if ($number < $start){
			$skip = (7*($start-$number-1)) + 6;
			$flag = 1;
			return "";
		}
		#is we are already finished
		elsif ($number > $end){
			$skip = 1000;
			return "";
		}
		#if we need to print U's at start
		elsif (($flag == 0) and ($number > $start)){
			#find out how many times we need to print
			$dif = $number - $start;
			while ($dif > 0){
				print OUT $u;
				$dif--;
				$node += $u_tot;
			}
		}
		#flag indicating non-mutant residue
		$mut_vis = 0;
		$flag = 1;
		#if this is the end increment flag to avoid printing later
		if ($number == $end){
			$flag = 2;
		}
	}
	else{
		#flag indicating mutant residue
		$mut_vis = 1;
		$line =~ s/Mut\t//;
	}
	return $mut_vis;
}

sub printPSSM{
	my( $line, $ind ) = @_;
	#get change at mutant
	@ps = split (/\t/o, $line);
	$aa_c = 0;
	my $x;
	foreach $amino_acid (@amino){
		if ($amino_acid eq $org){
			$wt_f = $ps[$aa_c];
		}
		elsif ($amino_acid eq $sub){
			$mt_f = $ps[$aa_c];
		}
		$aa_c++;
	}
	if ($wt_f >= $mt_f){
		$x= "0";
	}
	else{
		$x= "100";
	}
	$wt_f = sqrt(($wt_f-$mt_f)*($wt_f-$mt_f));
	$node += 2;
	return "$x\t$wt_f\t";
}
